<?php


class nodeaspect_PageInfoCache {

  protected $pages = array();
  protected $active;

  function reset() {
    $this->pages = array();
  }

  function pageInfo($node, $suffix) {
    if (!isset($this->pages[$node->nid][$suffix])) {
      $this->pages[$node->nid][$suffix] = _nodeaspect_page_info_build($node, $suffix);
    }
    return $this->pages[$node->nid][$suffix];
  }

  function page($node, $suffix) {
    $page_info = $this->pageInfo($node, $suffix);
    $this->active = array($page_info, $node, $suffix);
    return $page_info->page($node);
  }

  function hook_pageapi($api) {
    // This will trigger access callbacks.
    $api->initLocalTasks();
    foreach ($this->pages as $nid => $pages) {
      foreach ($pages as $suffix => $info) {
        $weight = $info->localTaskWeight();
        if (isset($weight)) {
          $api->moveLocalTask('node/%/'. $suffix, $weight);
        }
      }
    }
    if (!empty($this->active)) {
      list($page_info, $node, $suffix) = $this->active;
      $page_info->hook_pageapi($api, $node, $suffix);
    }
  }
}
